/*
 * AtomTypeDescriptor_impl.cpp
 *
 *  Created on: Feb 25, 2010
 *      Author: crueger
 */

#include "Descriptors/AtomTypeDescriptor.hpp"
#include "Descriptors/AtomTypeDescriptor_impl.hpp"

#include "atom.hpp"
#include "World.hpp"
#include "periodentafel.hpp"

AtomTypeDescriptor_impl::AtomTypeDescriptor_impl(element* _type) :
  type(_type)
{}

AtomTypeDescriptor_impl::~AtomTypeDescriptor_impl()
{}

bool AtomTypeDescriptor_impl::predicate(std::pair<int,atom*> atom) {
  return (atom.second->getType()==type);
}

AtomDescriptor AtomByType(element *elem){
  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomTypeDescriptor_impl(elem)));
}

AtomDescriptor AtomByType(int Z){
  element * elem = World::get()->getPeriode()->FindElement(Z);
  return AtomByType(elem);
}
